﻿namespace QuadTreeLib
{
    public struct RectangleF
    {
        float _x;
        float _y;
        float _width;
        float _height;
        float _x2;
        float _y2;

        public RectangleF(float pX, float pY, float pWidth, float pHeight)
        {
            _x = pX;
            _y = pY;
            _width = pWidth;
            _height = pHeight;
            _x2 = pX + pWidth;
            _y2 = pY + pHeight;
        }

        public static RectangleF Empty { get { return new RectangleF(0, 0, 0, 0);} }

        public bool IsEmpty 
        {
            get { return _width == 0.0f && _height == 0.0f; }
        }

        public float X
        {
            get { return _x; }
            set
            {
                _x = value;
                _x2 = _x + _width;
            }
        }

        public float Y
        {
            get { return _y; }
            set
            {
                _y = value;
                _y2 = _y + _height;
            }
        }

        public float Width
        {
            get { return _width; }
            set
            {
                _width = value;
                _x2 = _x + _width;
            }
        }

        public float Height
        {
            get { return _height; }
            set
            {
                _height = value;
                _y2 = _y + _height;
            }
        }

        public float X2
        {
            get { return _x2; }
        }

        public float Y2
        {
            get { return _y2; }
        }

        public bool Contains(RectangleF rect)
        {
            return (rect.X >= this.X && rect.Y >= this.Y && rect.X2 <= this.X2 && rect.Y2 <= this.Y2);
        }

        public bool IntersectsWith(RectangleF rect)
        {
            return (this.X + this.Width >= rect.X && this.Y + this.Height >= rect.Y && this.X <= rect.X + rect.Width && this.Y <= rect.Y + rect.Height);
        }
    }
}
